airavata_mft/apps/workspace/urls.py
from . import views
from django.conf.urls import url

app_name='workspace'
urlpatterns = [
    url(r'^storage/$', views.storage,name="storages"),
    url(r'^storage/(?P<storage_id>[^/]+)/$', views.resources,name="resources")
]

airavata_mft/urls.py
from django.contrib import admin
from django.urls import include
from django.conf.urls import url

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^workspace/', include('airavata_mft.apps.workspace.urls'))
]

airavata_mft/apps/workspace/models.py
from django.db import models

# Create your models here.

airavata_mft/apps/workspace/views.py
from django.shortcuts import render
import json
# Create your views here.


def storage(request):
    # TODO: grpc calls to backend
    storage_json = [{"storageId": "ssh-storage1", "name": "One Drive", "size": "20GB", "occupied": "10GB", "lastModified":"01/15/2020", "host": "localhost", "port": 22, "user": "root"},
                    {"storageId": "ssh-storage1", "name": "Google Drive", "size": "10GB", "occupied": "10GB", "lastModified":"01/16/2020", "host": "scp1", "port": 22, "user": "root"},
                    {"storageId": "ssh-storage1", "name": "Box", "size": "30GB", "occupied": "10GB", "lastModified":"02/15/2020", "host": "scp2", "port": 22, "user": "root"},
                    {"storageId": "ssh-storage1", "name": "Drop Box", "size": "40GB", "occupied": "10GB", "lastModified":"01/15/2019"}]

    return render(request, 'storage.html', {'bundle_name': 'storage',
                                            'data': json.dumps(storage_json),
                                            'title': 'Storage Unit'})


def resources(request, storage_id):
    resource_json = [{"resourceId": "Spring project", "name": "Spring project", "size": "11 GB", "lastModified": "01/15/2020"},
                     {"resourceId": "Trial", "name": "Trial", "size": "12 GB", "lastModified": "02/15/2020"},
                     {"resourceId": "New", "name": "New", "size": "13 GB", "lastModified": "03/15/2020"},
                     {"resourceId": "Random testing", "name": "Random testing", "size": "14 GB", "lastModified": "01/16/2020"}]
    return render(request, 'resources.html', {'bundle_name': 'resources',
                                              'data': json.dumps(resource_json),
                                              'title':  storage_id})

airavata_mft/apps/workspace/templates/container-header.html
{% extends "base.html" %}

{% load static %}
{% load render_bundle from webpack_loader %}

{% block scripts %}
    {% render_bundle "chunk-vendors" config='WORKSPACE'%}
    {% render_bundle bundle_name config='WORKSPACE'%}
{% endblock scripts %}

{% block app %}
    
<div id={{ bundle_name }}></div>
{% endblock app %}

airavata_mft/apps/workspace/templates/resources.html
{% extends "container-header.html" %}

{% block app %}
    
<div id={{ bundle_name }} data-resources-list="{{ data }}" data-title ="{{ title }}"></div>
{% endblock app %}

airavata_mft/apps/workspace/templates/storage.html
{% extends "container-header.html" %}

{% block app %}
    
<div id={{ bundle_name }} data-storage-list="{{ data }}" data-title ="{{ title }}"></div>
{% endblock app %}

airavata_mft/templates/base.html
{% load static %}
{% load render_bundle from webpack_loader %}

<!DOCTYPE html>
<head>
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
	</head>
{% block scripts %}
{% endblock scripts %}
{% render_bundle 'chunk-vendors' config='DEFAULT'%}
{% render_bundle 'app' config='DEFAULT'%}

	<body>
		<nav class="navbar navbar-light header shadow-sm">
			<div class="container-fluid">
				<div class="col-2">
					<a class="navbar-brand" href = "{% url 'workspace:storages' %}">
						<div class="row">
							<div class="col-5">
								<img class="logo" src="{% static 'images/airavata-logo.png' %}">
								</div>
								<div>
									<div class="col-8">
										<div class="row apache">
											<span class="header-text apache-text">APACHE</span>
										</div>
										<div class="row airavata">
											<span class="header-text airavata-text">AIRAVATA</span>
										</div>
									</div>
								</div>
							</div>
						</a>
					</div>
					<div class="col-8 search-div">
						<div class="form-group has-search">
							<span class="fa fa-search form-control-feedback"></span>
							<input type="text" class="form-control" placeholder="Search">
							</div>
						</div>
						<div class="col-2">
							<div class="row user-div">
								<i class="fa fa-user-circle fa-2x"></i>
								<div class="dropdown">
									<a class="btn dropdown-toggle header-drop-down" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">Admin</a>
									<div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
										<a class="dropdown-item" href="#">Logout</a>
									</div>
								</div>
							</div>
						</div>
					</div>
				</nav>
				<!-- side navigation bar (Needs to move to a vue template)-->
				<div class="container-fluid">
					<div class="row">
						<div class="col-2" style="padding-top: 1.5%">
							<nav class="nav flex-column">
								<a class="c-nav__item selected-nav" href= "{% url 'workspace:storages' %}">
									<i class="fa fa-database nav-icon"></i>Storage Units
								</a>
								<a class="c-nav__item" href="#">
									<i class="fa fa-users nav-icon"></i>Users
								</a>
								<a class="c-nav__item" href="#">
									<i class="fa fa-cogs nav-icon"></i>Agents
								</a>
								<a class="c-nav__item" href="#">
									<i class="fa fa-book nav-icon"></i>Audit
								</a>
							</nav>
						</div>
						<div class="col-10 main-app">
                {% block app %}
                {% endblock app %}
            </div>
					</div>
				</div>
			</body>
			<style>
     /* Side Navigation Bar */
    .selected-nav{
        margin-right: 0.5em;
        color: lightblue;
        padding: 1em;
        font-size: 1rem;
        display: block;
    }
    .c-nav__item {
        color: grey;
        padding: 1em;
        font-size: 1rem;
        display: block;
        background-color: white;
        padding-bottom: 0%;
    }
    .c-nav__item:hover{
        background-color: #d6d8db!important;
    }
    .nav-icon {
        padding-right: 10%;
        padding-left: 14%;
    }
    .c-nav__item:hover{
        color: #17a2b8;
        text-decoration: none;
        font-weight:bold;
    }
       /* Top Navigation */

    .header {
        background-color: white;
        padding-top: 2%;
    }
    .logo{
        height: 57px;
    }
    .header-text{
        color: grey;
    }
    .header-drop-down {
        color: black;
        background-color: white;
        border: white;
    }
    .apache {
        height: 0.7em;
    }
    .apache-text{
       font-size: smaller;
    }
    .airavata-text{
        font-size: larger;
    }
    
    /* Bootstrap 4 text input with search icon */

    .form-control {
        padding-left: 2.375rem;
        background-color: #DCDCDC;
        max-width: 58%;
    }

    .has-search .form-control-feedback {
        position: absolute;
        z-index: 2;
        display: block;
        width: 2.375rem;
        height: 2.375rem;
        line-height: 2.375rem;
        text-align: center;
        pointer-events: none;
        color: #aaa;
    }
    .search-div{
        padding-left: 0%;
    }
      /* main-app */
    .main-app{
        padding-top: 1.5%
    }
</style>